\documentclass[
	11pt, 
	DIV10,
	a4paper, 
	oneside, 
	headings=normal, 
	captions=tableheading,
	final, 
	numbers=noenddot
]{scrartcl}


\usepackage{lipsum}
\usepackage{graphicx}
\usepackage[table]{xcolor}
\usepackage{amsmath}
\usepackage{textcomp}
\usepackage[parfill]{parskip}
\usepackage{float}
\usepackage{subcaption}
\usepackage{algpseudocode}
\usepackage{algorithm}
\usepackage{listings}
\usepackage{amssymb}
\usepackage{hyperref}
\usepackage[euler]{textgreek}
\def\todo#1{{\color{red}{\bfseries \fbox{ToDo}}\enspace #1}}

\colorlet{punct}{red!60!black}
\definecolor{background}{HTML}{EEEEEE}
\definecolor{delim}{RGB}{20,105,176}
\colorlet{numb}{magenta!60!black}
\lstdefinelanguage{json}{
    basicstyle=\normalfont\ttfamily,
    numbers=left,
    numberstyle=\scriptsize,
    stepnumber=1,
    numbersep=8pt,
    showstringspaces=false,
    breaklines=true,
    frame=lines,
    morecomment=[l][\color{gray}]{\#},
    backgroundcolor=\color{background},
    literate=
     *{0}{{{\color{numb}0}}}{1}
      {1}{{{\color{numb}1}}}{1}
      {2}{{{\color{numb}2}}}{1}
      {3}{{{\color{numb}3}}}{1}
      {4}{{{\color{numb}4}}}{1}
      {5}{{{\color{numb}5}}}{1}
      {6}{{{\color{numb}6}}}{1}
      {7}{{{\color{numb}7}}}{1}
      {8}{{{\color{numb}8}}}{1}
      {9}{{{\color{numb}9}}}{1}
      {:}{{{\color{punct}{:}}}}{1}
      {,}{{{\color{punct}{,}}}}{1}
      {\{}{{{\color{delim}{\{}}}}{1}
      {\}}{{{\color{delim}{\}}}}}{1}
      {[}{{{\color{delim}{[}}}}{1}
      {]}{{{\color{delim}{]}}}}{1},
}

\def\staubli{\textit{St\"aubli}\enspace }

\title{\LARGE Code Generation for 3D-printing a Heart Valve}
%\subtitle{\vspace{0.5cm}Seminar: }
\author{Florian H\"ovelmann}

\begin{document}
\maketitle

\section{Introduction}
Patient-specific models of cardiovascular structures like heart valves have been used in a variety of different applications. For example, 3D functional flow models of patients with aortic valve dysfunction have been used to provide deeper insights into the blood flow characteristics and to test suitable devices~\cite{cardiac1}. Realistic replicas of vascular structures are also used as a teaching tool for medical students. In very unique diseases like congenital heart conditions, 3D models help to plan and simulate the required patient specific operation procedure~\cite{cardiac1}. Having 3D models of different heart conditions also offers additional testing possibilities for new devices and thus enhances their innovation~\cite{cardiac1}. Currently, there is also a lot of research on patient-specific cardiovascular prostheses~\cite{cardiac1, cardiac2}. However, a lot of issues with these approaches still have to be solved. The most obvious is the modulation error that can occur at any stage of the process and may severely harm the patient depending on the application. Some authors argue that the "actual clinical benefit of 3D printing yet remains to be proven"~\cite{cardiac2}. Thus, further research and development are needed before the 3D printing of vascular structures becomes a common tool in medicine.\\

\begin{figure}[h]
\centering
	\includegraphics[scale=0.2]{images/completeProcedure}
	\caption{All steps required to obtain a patient-specific 3D heart model, taken from~\cite{cardiac1}. Here CT images were used where the relevant parts are segmented from and combined to a 3D reconstruction. The digital model was adopted for the usage in flow loop before being printed as a final step.}
	\label{fig:completeProcedure}
\end{figure}


To generate models of patient-specific vascular structures, they first need to be scanned. The most used method for this is computed tomography followed by ultrasound imaging. Next, 2D slices of the acquired 3D data are segmented and combined to create the desired 3D model. This model is typically represented using an STL file which will be introduced shortly. Lastly, the digital model is printed out, see Figure~\ref{fig:completeProcedure}. Four different categories of 3D printing techniques have been applied for this. Most known from commercial 3D printers is the fused deposition modeling which deposits a melted filament layer by layer. Polyjet technology works similarly with the difference that a polymeric resin is hardened using UV light. Selective laser melting creates the 3D model from a ceramic powder and a powerful laser. Stereolithography hardens specific spots in a pool of liquid substance by UV light. Since special materials have to be utilized when replicating cardiovascular structures, some printing methods are preferred over others. The most common method is stereolithography as it is able to print flexible as well as transparent materials~\cite{cardiac2}. However, the printing methods are typically not feasible for materials like polyurethane which has been widely used in medicine due to its advantageous properties, especially its biocompatibility.  
A very recent paper successfully combined fused deposition modeling with polyurethane and evaluated the mechanical properties~\cite{poly}. But due to the layer by layer printing, the surface is not very smooth possibly leading to hemolysis. Another study done at the ETH developed a custom printing technique referred to as direct ink writing to precisely print the desired shape~\cite{eth}. Mandrels serve as a supporting structure that are hold by a robot, see Figure~\ref{fig:eth}. This method can handle a range of different materials.  A key result in~\cite{eth} is a larger effective orifice area of a heart valve while reducing the regurgitation. Therefore, a similar printing technique is also used in this report but with polyurethane instead of silicone and a monomer as in~\cite{eth}. The idea is to combine precise printing with the benefits of polyurethane. However, the main focus of this report is to simplify the robot control for the printing process.

In the rest of this section, the requirements of the printing process are described and the relevant background information is given. Section~\ref{sec:codeGen} further defines the requirements from which the steps to generate \staubli code are established. After a detailed view of the different steps, a short description on how to operate the \staubli robot as well as the developed software is given in Section~\ref{sec:manual}. Lastly, the procedure is validated in Section~\ref{sec:validate}.

\begin{figure}[h]
\centering
	\includegraphics[scale=0.3]{images/eth}
	\caption{Individual heart valve printing procedure based on a combination of direct ink writing and substrate spraying taken from~\cite{eth}.}
	\label{fig:eth}
\end{figure}


\subsection{Preliminaries}
As stated in the introduction our attempt of printing a heart valve is based on a robot arm holding a supporting structure onto which the polyurethane is applied. It includes a mechanism controlling the pipette as well as a heating plate offering a more controlled cool down of the polyurethane. But the aim of this report is mainly to offer a simple way of controlling the robot arm. Any other controllable part like the heating plate should, however, be straightforward to integrate into the existing code.

\subsubsection{Requirements}
\label{sec:requirements}
With the setup in mind, we can formulate the first requirements to the software. Since one of the key objectives in 3D printing a heart valve is to be able to create individual geometries, the software needs to include this. Additionally, parts of the heart valve might require different printing patterns than others. Therefore, the printing process itself should be customizable. However, there clearly is a trade-off between adaptability and ease of use. For example, one would achieve the most flexible solution if the user types in all points as well as the code to execute, but it would be impracticable. Thus, the software needs to offer a straightforward way of generating the desired code from a 3D representation of the heart valve while still being adjustable.\\

Before getting to the process of generating the code for the \staubli TX60 robot, a brief introduction into some required background information is given in the following.

\subsubsection{Robot}
\label{sec:preRobot}
A comprehensive overview of the TX60 robot is out of the scope of this report but can be found in~\cite{tx60}. Here, only the most important concepts for this project are discussed. The programming language of the \staubli robot is called Val3~\cite{val3}. Each program consists of four files. The \verb|<program_name>.pjx| gives references to the other files, \verb|<program_name>.dtx| contains all data objects like points that have been defined, \verb|start.pgx| and \verb|stop.pgx| consist of the code that is executed. XML is used as a file format for all Val3 files. For example, the definition of a Cartesian point $a=[1,2,3]$ in mm is given by:

\lstset{language=XML}
\begin{lstlisting}
<pointSection>
  <point name="a" public="false">
    <pFather alias="" name="world" fatherIndex="0" />
    <valuePoint index="0">
     <tpValue x="1" y="2" z="3" rx="0.0" ry="0.0" rz="0.0" />
     <cpValue shoulder="ssame" elbow="esame" wrist="wsame" />
    </valuePoint>
  </point>
</pointSection>
\end{lstlisting}
Here, $rx,ry,rz$ define the orientation of the tool using Euler angles~\cite{rotation}. Each point is defined in a specific coordinate system which is referencing the world coordinate system at the top level. This approach is also very common in computer graphics~\cite{ComGra}. The world coordinate system itself has its origin at the end of the robot arm. For example, a new coordinate system \verb|fWork| whose origin is the pipette tip can be specified in the frame section. In order to move the robot arm to a specific point, instructions like \verb|movel(a,flange,mNomSpeed)| can be used where \verb|flange| references the tool that is used and \verb|mNomSpeed| the speed of the movement. A tool describes a certain offset to the tip of the robot arm. 

\subsubsection{STL}
As stated in the beginning printing a heart valve requires a representation of its 3D structure. A common way to do this is using STL files. Like in almost all computer graphics applications they use triangles to represent the 3D structure of an object. Each of the triangles consist of three vertices and a normal to define the orientation of the triangle. Note that there exist more memory efficient representations that reuse shared vertices or use the order of vertices to define the orientation avoiding the need for a normal~\cite{stl}. However, due to their wide usage and their simplicity STL files are used in the following.

\section{From the Model to the Val3 Code}
\label{sec:codeGen}
\begin{figure}[H]
\centering
	\includegraphics[scale=0.8]{images/pipelineStart}
	\caption{Illustration of the software's input and output }
	\label{fig:pipelineStart}
\end{figure}
Now that a brief introduction of STL files as the input of the program and Val3 files as the output is given, it remains to discuss how the Val3 files are obtained, see Figure~\ref{fig:pipelineStart}. Since there is no direct way of loading and handling STL files in Val3 itself, intermediate software is needed. For this Python is used as the basics of the language are easy to understand even without experience in programming. This makes it much easier for anyone to make adjustments to the code if needed later. To infer the needed processing steps, the requirements of Section~\ref{sec:requirements} should be extended. By relying on STL files as the basis, an individual heart valve can already be expressed. The goal then is to generate points on the surface of the model and how they are traversed, compare step C in Figure~\ref{fig:eth}. Additionally, the robot arm needs to orient the basis on which the polyurethane is applied in an upright position such that the drops do not fall off. To achieve this, the normal at each point should be stored. The printing process itself also needs to be customizable by offering basic options.\\

As illustrated in Figure~\ref{fig:pipelineStart}, JSON files are used to have a central place for any possible options. A more detailed description can be found in Section~\ref{sec:system}. Now to actually generate points on the 3D model one can use existing algorithms capable of generating evenly distributed points on curved surfaces~\cite{point1, ethpoint}. However, they often lag the ability to adjust how the points are distributed and do not offer a straightforward way to obtain the normals. Researchers from the ETH utilized a method described in~\cite{eth} for this problem. It assumes the surface to be locally flat resulting in a set of small planes from which a metric can be computed to calculate geodesics. On curved surfaces, geodesics are the equivalent of a straight, i.e. shortest path between two points. Note that the shortest path on curved surfaces might not be as obvious as on flat ones. By following geodesics it becomes possible to accurately print specific replicating patterns without any distortion while staying on the surface. Even though this method achieves very uniform paths, it also limits the patterns that are possible to print. Therefore, we aim to provide a method that is able to handle irregular patterns and offers an intuitive way to define them.\\

\begin{figure}[H]
\centering
	\includegraphics[scale=1.2]{images/pipeline}
	\caption{Outline of the steps required to obtain the desired VAL3 code from the STL file}
	\label{fig:pipeline}
\end{figure}

On a flat two-dimensional surface, the problem is much easier as we can directly specify where the points lie and how they are traversed. Thus, our goal is to somehow project the surface of the 3D model onto a 2D plane while preserving distances as much as possible. The latter is important to maintain the distribution of the points when projecting them back onto the 3D model. However, looking at the complexity of a heart valve there is no clear way how to obtain such a projection. A common approach from computer science called divide and conquer can be utilized to get around this problem. The idea is to divide the heart valve model into subsurfaces and solve the problem for each subsurface. Doing so also allows fulfilling the requirement of individually printing each part of the heart valve. An example of such a division is illustrated in the first step of Figure~\ref{fig:pipeline}. The remaining projection problem is closely related to the topic of texture mapping in computer graphics. Here, a two-dimensional texture needs to be mapped onto a three-dimensional object. As a solution to this, different geometries like planes, cylinders, or spheres are used to approximate the real object. For example, the basis of the heart valve in the second step of Figure~\ref{fig:pipeline} is very well approximated using a cylinder. From these geometries, it is straightforward to derive an appropriate projection onto the plane. After this, points on the plane can be defined in a variety of ways, see step three of Figure~\ref{fig:pipeline}. Lastly, the exact coordinates on the 3D model including the normal need to be calculated. Again, a method from computer graphics called raytracing solves the issue. From the points on the projection plane, rays are generated to determine where the points would end up on the model, see step four of Figure~\ref{fig:pipeline}. With this, all required information of the heart valve model is obtained and the Val3 file can be generated. \\
In the following, a closer look into each step of the required steps is given.



\subsection{Subdividing the Model}
\begin{figure}[h]
\centering
	\includegraphics[scale=0.7]{images/triangleGraph.png}
	\caption{Adjacency graph with nodes shown in blue and edges in red of a triangulation shown in black.}
	\label{fig:triangleGraph}
\end{figure}
Dividing the model relies on a clear classification of the triangles where each class describes one subsurface\footnote{stlprocessing.py: get\_all\_surfaces, get\_surface\_connection}. The classification itself is based on adjacency graphs\footnote{stlprocessing.py: build\_face\_adjacency\_graph} as shown in Figure~\ref{fig:triangleGraph}. Each triangle is represented by a node in the graph and the connection to other triangles by an edge. Since a triangle is connected to at most three other triangles, each node has at most three edges. Starting from one node, the adjacent triangles are checked by some method whether they belong to the same class as the current triangle. In our case, the method checks if the angle between the triangles, or more precisely, between their normals is below a given value. Then the process repeats for all triangles of the same class. To avoid double-checking any triangle, the algorithm marks all processed ones and first looks up if the triangle has been checked already. In computer science such an algorithm is called breadth-first search since all neighboring nodes are checked before continuing with the next node. Once all triangles of one class have been found, a new class is started at a random not classified triangle until all triangles are classified. The result of such a classification can be found in   Figure~\ref{fig:step1}.

\begin{figure}[H]
\centering
	\includegraphics[scale=0.7]{images/step1.png}
	\caption{Desired result of a heart valve model subdivided into its subsurfaces shown by different colors.}
	\label{fig:step1}
\end{figure}

\subsection{Approximation of the Subsurfaces}

\begin{figure}[H]
\centering
	\includegraphics[scale=0.7]{images/symmetry_point.png}
	\caption{3D illustration of how a point on the symmetry axis is obtained by intersecting two lines in 2D for the case of a perfect cylinder mesh shown in gray. The cylinder forms a circle shown in black when projecting it onto the plane perpendicular to the symmetry vector. The red lines originate at some projected triangles and follow the direction of their normals.}
	\label{fig:symPoint}
\end{figure}


Now that the subsurfaces are obtained, a suitable approximation of the surface needs to be determined. With this, the surface can be projected onto a plane while preserving distances to avoid distortions when projecting points on the plane back onto the surface. In this project, two types of geometries are considered, planes and cylinders. Thus, there needs to be some measure to decide if a surface is better represented by a plane or by a cylinder based on their characteristics. For a planar surface, all triangles should share the same normal\footnote{stlprocessing.py: get\_planarity\_axis}. A cylindric surface has a symmetry axis in the middle of the cylinder. The orientation of the axis can be computed by the cross product of two non-equal normals\footnote{stlprocessing.py: get\_symmetry\_axis}. To obtain a point on the axis and thus fully describe the axis, the centers of the triangles are first projected on the plane perpendicular to the symmetry axis. For an exact cylinder, this would result in a circle where each of the normals or their negation point towards the center, see Figure~\ref{fig:symPoint}. Therefore, a point on the symmetry axis can be computed by intersecting two lines each being defined by the projected triangle center and the normal\footnote{stlprocessing.py; utils.py: get\_symmetry\_point; line\_intersection\_2d}. Since the subsurfaces might not exactly resemble a plane or cylinder, the computations above are repeated for different triangles. The deviation from an ideal result of each surface type is then used to determine whether the surface is better represented by a plane or by a cylinder. Figure~\ref{fig:step2} illustrates the approximating surfaces for the subsurfaces of a heart valve model.

With this information, the projection of the subsurface onto the approximating surface could directly be carried out. However, the required calculations are largely simplified if the symmetry axis or planar normal is aligned with the global z-axis\footnote{stlprocessing.py: transform\_to\_projection}. In the case of a planar subsurface, only one rotation needs to be applied. Without getting into too much detail, the rotation itself is represented by a 4x4 homogeneous matrix~\cite{ComGra} and is applied by multiplying it with the points and normals of the subsurface. Again the concept of homogeneous matrices comes from the field of computer graphics and is described in~\cite{ComGra}. For cylindric subsurfaces, the symmetry axis needs to match the z-axis requiring another translation after the initial rotation. All transformations need to be reversible resulting in two states of the subsurface, i.e. the original state and the projection state\footnote{stlprocessing.py: StlSubmesh.isTransformed, transform\_to\_original, transform\_to\_projection}. The projection of the subsurface itself is straightforward once it is in the projection state\footnote{stlprocessing.py; utils.py: get\_plane\_proj; proj\_flat, proj\_cylindric}. For planar subsurfaces, the z-component is simply disregarded. Cylindric surfaces, on the other hand, keep the z-component and use the angle to the x-axis as a second coordinate, see Figure~\ref{fig:convexHull}.\\
From the projected triangles, appropriate points on the projection plane can be generated which will be discussed in the next section.

\begin{figure}[H]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.49\textwidth}
		\centering
		\includegraphics[scale=0.6]{images/step22.png}
		\caption{Cylindric heart valve leaflet}
	\end{subfigure}
	\hspace{0.5cm}
	\begin{subfigure}[t]{0.49\textwidth}
	  \centering
		\includegraphics[scale=0.6]{images/step2.png}
		\caption{Cylindric heart valve base}
	\end{subfigure}
	\caption{Surface approximation illustrated in light gray of the different subsurfaces.}
	\label{fig:step2}
\end{figure}


\subsection{Generating Points on the Projection Plane}
\begin{figure}[H]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.49\textwidth}
		\centering
		\includegraphics[scale=0.45]{images/convexHullLeaf.png}
		\caption{Cylindric heart valve leaflet}
	\end{subfigure}
	\hspace{0.3cm}
	\begin{subfigure}[t]{0.49\textwidth}
	  \centering
		\includegraphics[scale=0.45]{images/convexHullBase.png}
		\caption{Cylindric heart valve base}
	\end{subfigure}
	\caption{Convex hull shown in red of the projected triangle vertices of two subsurfaces from the heart vavle model shown in blue.}
	\label{fig:convexHull}
\end{figure}
There are a variety of different patterns to distribute and traverse the points on the projection plane. Currently four types of patterns are supported that are set in \verb|printing.json|. All of them distribute points in a rectangular grid but differ in how these points are traversed. The first two start at the upper left one going top down and then left to right and the other first left to right and then top down. The other two go either inwards to the center or outwards from the center. Technically, all of the points could be forwarded to the next step. But in order to save computation time, some points that will not end up on the subsurface are removed already. In Figure~\ref{fig:pointGeneration} one can see that some generated points are lying outside the projected subsurface. A point on the 2D projection plane can be extended into a ray in 3D containing all points that would be end up in this projection point. In the case of a planar subsurface for example, the ray of the point $p=[1,2]$ is given by the set $\{r = [1,2,z]\ |\ z \in \mathbb{R}\}$. Thus, the corresponding ray of a point outside the projected subsurface will not hit the subsurface in 3D. The intuition of what lies inside the projected subsurface is captured by its convex hull. To get a better understanding of what this hull represents one can think of the projected vertices being nails hammered into a surface. The convex hull then corresponds to a rubber band spanned around the nails, see Figure~\ref{fig:convexHull}. It is described by a polygon and there exist efficient methods to determine if a point is inside or outside this polygon. However, it should be noted that not all rays of points in the convex hull will actually hit the subsurface, see Figure~\ref{fig:pointGeneration}. Therefore, a point being inside the hull is a necessary but not sufficient condition for the resulting ray to hit the surface.\\
After disregarding all points outside the convex hull, the remaining points are forwarded to the raytracing step.

\begin{figure}[H]
\centering
	\includegraphics[scale=0.5]{images/pointGeneration.png}
	\caption{Generated points on flat projection surface shown in blue and potentially intersection ones in green. They are determined from the red convex hull of the projected heart valve base.}
	\label{fig:pointGeneration}
\end{figure}


\subsection{Raytracing}

\begin{figure}[h]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.49\textwidth}
		\centering
		\includegraphics[scale=0.6]{images/raytracing.png}
		\caption{Cylindric heart valve leaflet}
	\end{subfigure}
	\hspace{0.3cm}
	\begin{subfigure}[t]{0.49\textwidth}
	  \centering
		\includegraphics[scale=0.6]{images/raytracing_flat.png}
		\caption{Flat plate}
	\end{subfigure}
	\caption{Illustration of the generated rays shown in red within the raytracing step for a flat and a cylindric surface shown in green. The approximating surface of the flat plate is omitted to get a clear illustration.}
	\label{fig:step4}
\end{figure}

In order to obtain the points and normals on the subsurface in 3D, the 2D points need to be projected onto the surface\footnote{stlprocessing.py: set\_proj\_points\_normals}. Since the subsurface is only approximated by a plane or cylinder, there is no simple way to calculate where a point from the projection plane would lie on the surface. Thus, the ray corresponding to a point on the projection plane as described in the last section needs to be intersected with the subsurface in 3D. An illustration of this can be found in Figure~\ref{fig:step4}. But before performing the computationally expensive ray intersections, all points whose rays will not intersect the surface should be ruled out. The filtering is computed directly on the projection plane by checking if a points lies inside any of the projected triangles which also yields the required normal on the subsurface\footnote{utils.py: point\_in\_triangle\_2d}. An exact description of the underlying method is omitted here but can be found in~\cite{ComGra}. All remaining points on the projection plane get extended to their corresponding ray depending on the subsurface form\footnote{utils.py: get\_ray\_flat, get\_ray\_cylindric}. Then the actual ray intersection is performed to determine the intersection point on the subsurface\footnote{utils.py: intersect\_line\_triangle}~\cite{ComGra}. Since all of these operations are performed with the subsurface being in the projection state, the intersection points and normals need to be transformed before saving them.\\

After running each subsurface through the raytracing step, all required information from the 3D model of the heart valve is collected as shown in Figure~\ref{fig:step4} and the last step of generating \staubli code can be performed.

\begin{figure}[H]
\centering
	\includegraphics[scale=0.8]{images/step4.png}
	\caption{Final result of the raytracing step for all subsurfaces of the heart valve. The red path illustrates how the red points with a blue normals are traversed. }
	\label{fig:step4}
\end{figure}


\subsection{Generating Val3 Code}
\label{sec:code}
\begin{figure}[H]
\centering
	\includegraphics[scale=0.3]{images/valveFull2.png}
	\caption{Generated image of the subdivided heart valve showing the submesh indices used to define individual printing patterns.}
	\label{fig:valveFull}
\end{figure}
Before saving the calculated points to a Val3 file, they first need to be modified such that the robot moves the mandrel into the correct position and orientation under the printing tip. As stated in Section~\ref{sec:preRobot}, a separate coordinate system with the printing tip as the origin has been defined. Thus, for a point on the mandrel, the robot needs to it to the origin while accounting for the \verb|dripHeight| defined in the \verb|printing.json|. Then the normal at that point needs to be aligned with the z-Axis to avoid spilling material. However, this still leaves one degree of freedom namely a rotation around the z-Axis. To obtain a consistent movement, the robot then aligns the symmetry axis with its own x-axis for cylindrical surfaces. For planar surfaces, an arbitrary but constant axis is chosen.

The connection between python variables and Val3 files is handled by the \verb|StaubliProject| class in \verb|project.py|. On the python side, the code lines are stored in an array and the data points in a \verb|pandas| dataframe. 
They can automatically be written to the \staubli project files by saving the project which handles any parsing and transforming required\footnote{project.py: save}. Additionally, existing code and data can be extended by loading them into the \verb|StaubliProject| object or a new project can be created from the template files. Aiming for as much customization as possible, each subsurface can have its own printing definition as an entry in the \verb|submeshPrinting| array of the \verb|printing.json|. Since the subsurfaces and their order is not known beforehand, images are generated showing the subsurfaces and their naming, see Figure~\ref{fig:valveFull}. An important feature of the printing process is the ability to print over the same surface multiple times allowing to print a certain thickness. The thickness of polyurethane after one run is specified by \verb|thicknessPerRun| and the desired thickness by \verb|thickness| in mm. Thus, these parameters also determine how many runs are performed. Within each run, almost the same Val3 code is generated. Any code that should run before or after each printing point is reached gets specified in \verb|codePreDrip| and \verb|codePostDrip|, respectively. Macros, i.e. placeholders that are replaced by actual values are supported here. For example, if some code should only to be executed in the first run one can use the macro \verb|$run| which later gets replaced by the current run number. The last parameter \verb|dripHeight| is the height from which the drop should be released.  

\section{User Manual}
\label{sec:manual}
In the following subsections, an overview of how to use the project is given. First, the required steps to operate the \staubli TX60 robot arm are described before getting to the installation and execution of the software.

\subsection{Robot}
A detailed description of the \staubli TX60 robot arm, as well as the \staubli SRS Studio can be found in the folder \textit{CVE\_Students/Florian.Hoevelmann}. The aim of this sections is to give a brief overview of the required steps. First, the working area should be free of any objects and the robot turned on. It takes some time until the robot has started but once ready the lights on the remote should stop blinking. Then the control mode should be changed into remote control which allows the robot to continue even if no one holds the remote controller. This is done at the little box with the keys in it. The last step to get the robot in operating mode is to activate the dead man's handle which is done by pressing the button at the back of the remote and the start button simultaneously. To load a program choose \textit{Applikations Manager} $\rightarrow$ \textit{Val3 Applikation} $\rightarrow$ \textit{Festplatte} and then the desired program. It can then be started by clicking on \textit{run}, choosing the loaded program and pressing the \textit{move/hold} button. 

Loading a Val3 program onto the \staubli robot requires a computer with \staubli SRS Studio installed and a dongle. The latter serves as a certificate validation. Any communication between the robot and the computer runs over the local network. Therefore, the LAN cable needs to be plugged in. The IP address of the robot can change as it is not static. It is listed at \textit{Systemsteuerung} $\rightarrow$ \textit{Systemeinstellungen} $\rightarrow$ \textit{Netzwerk} $\rightarrow$ \textit{J204 IP Addresse} on the remote controller. Within SRS Studio the connection to the robot can be verified by clicking on \textit{Transfer Manager} and \textit{Ping}. Once this is verified any program can easily be uploaded into the robot by opening the program and clicking on \textit{Upload Application}.


\subsection{System}
\label{sec:system}
To run the project code, some requirements have to be fulfilled. First the project itself needs to be downloaded from \href{https://git.rwth-aachen.de/hoevelmann.florian/staublimedi}{\color{blue} \textit{GitLab}}. Then there are two options on how to install the project. One option is to install  all the programs and libraries that are needed manually on the system. Those include \verb|python|, \verb|jupyter| and the libraries \verb|numpy|, \verb|matplotlib|, \verb|scipy|, \verb|sklearn|, \verb|trimesh| and \verb|pandas|. To simplify the installation process the other option relies on a Dockerfile as well as an installation script. For those who are not familiar, docker allows running an individual container and thus encapsulating all software that might need to be installed. Even though there are clear differences between docker and a virtual machine, for simplicity one can think of the container as being a virtual machine. From the Dockerfile, docker can automatically download and install everything. Thus, the only thing to be installed prior to running the installation script is docker itself. On Linux, the process is straightforward and can be found on the docker webpage. For Windows based systems, the process is a bit more complicated. First the linux bash shell for Windows 10 needs to be installed. Afterwards, docker itself can be installed which again is explained on the docker webpage. Once these requirements are fulfilled, one can simply run the installation script by running \verb|./install|. The script will download and build the docker image and stop the running container once finished.\\

Now there are two options on how to use the project code. One option is to use the jupyter notebooks that allow running python code in the web browser. To do this one needs to run the following command in a linux based shell.
\begin{verbatim}
sudo docker start -a staublicontainer
\end{verbatim}
which will print out something similar to
\begin{verbatim}
    ...
    To access the notebook, open this file in a browser:
        file:///home/jovyan/.local/share/jupyter/runtime/...
    Or copy and paste one of these URLs:
        http://3bc956921d52:8888/?token=0d86ab8843d928c0942ac4d8dca5e41
     or http://127.0.0.1:8888/?token=0d86ab8843d928c0942ac4d8dca5e4.
\end{verbatim}
As written, the notebook can be accessed through the links provided. Different notebooks are given including visualizations of each step in the process of generating Val3 code. This should simplify any adjustments later help to better understand the program. Alternatively, one can use the automation script to automatically process the inputs provided. It expects the path to the configuration and printing files \verb|config.json|, \verb|printing.json| as a first argument and the path to the json schema files as a second. The latter is found in the \verb|jupyter/staubli/| folder and used to validate the JSON files. The possible parameters of the JSON files are also described here. All input files meaning the \verb|config.json|, \verb|printing.json| and \verb|<model>.stl| should lie in the same folder. After the docker container is started a call to the automation script could look like the following
\begin{verbatim}
./automation jupyter/valveTest/ jupyter/staubli/ 
\end{verbatim}

\begin{lstlisting}[label=list:config,language=json,firstnumber=1,caption={Example of the config.json for the heart valve model},captionpos=b]
{
    "staubliFolder": "valveTest/",
    "stlPath": "valveTest/valve.stl",
    "directProcessing": false,
    "singleStaulbiFile": true,
    "generateImages": true,
    "generateStaubliFile": true
}
\end{lstlisting}

\begin{lstlisting}[label=list:print,language=json,firstnumber=1,caption={Example of the printing.json for the heart valve model},captionpos=b]
{
    "submeshPrinting": [{
      "submeshId": 0,   
      "dripHeight": 1,
      "codePreDrip": [],
      "codePostDrip": [],
      "thickness": 0.1,
      "thicknessPerRun": 0.1,
      "points": {"distance": 7.5, "pattern": "topDown"}
    },{
      "submeshId": 1, # Heart valve base
      "dripHeight": 1,
      "codePreDrip": [],
      "codePostDrip": [],
      "thickness": 0.2, # Two runs for the base
      "thicknessPerRun": 0.1,
      "points": {"distance": 4.5, "pattern": "topDown"}
    }
    ... # Definition for the other two leaflets
    ],
    "reusePrinting": false
}
\end{lstlisting}

There are four example models \verb|jupyter/valveTest/|, \verb|jupyter/flatTest/|,\newline \verb|jupyter/cubeTest/|, \verb|jupyter/cubeCylindricTest/| including their JSON that were used as a validation of the software. The json files for the heart valve model can be found Listing~\ref{list:config} and \ref{list:print}. They give a simple overview of how the input files should look like. The parameters for the \verb|printing.json| have been described in Section~\ref{sec:code}. Since the \verb|config.json| file contains any configuration for the code generation, a brief overview of the parameters is given in the following. The \verb|staubliFolder| points to the folder where the Val3 files should be saved and the path to the STL model is specified in \verb|stlPath|. With \verb|directProcessing| one can decide whether the \verb|printing.json| needs to be adjusted after the subdivision step. This allows to correctly reference the subsurfaces within the \verb|printing.json|. When individual Val3 files for each of the subsurfaces should be generated the parameter \verb|singleStaulbiFile| is set to True. Lastly, the user can decide if images should be generated with \verb|generateImages| or if no Val3 files should be created by the parameter \verb|generateStaubliFile|.

If all required programs were directly installed on the system, it is of course still possible to use the same options when running the software. The jupyter notebooks can be started by typing \verb|jupyter notebook| within the folder \verb|jupyter/|. Running the automation script is also simple and can be done as follows
\begin{verbatim}
python staubli/automation.py -j jupyter/valveTest/ -s jupyter/staubli/ 
\end{verbatim}


\section{Validation}
\label{sec:validate}
Now that the software as well as its usage has been described, the results need to be validated. Thus, the software itself as well as the execution on the robot is tested by a few test scenarios in the following.

\subsection{Software}
As an input to the software, five different 3D models were tested. They include a heart valve, cylinder, cube, flat plate, and a cube with cylindric top. The generated paths for the heart valve, cube with a cylindric top, and cylinder can be found in Figure~\ref{fig:valveTest},~\ref{fig:cubeCylinderTest} and~\ref{fig:cylinderTest}, respectively. As illustrated, there is an even distribution of the points, shown in red, on the surface, and the normals, shown in blue, match the expected ones. Moreover, the illustrated subdivision of each model takes the edges into account and thus aligns with an intuitive division. Besides handling different models, the software also offers a lot of customization of the printing process as stated in the last sections. These also have been tested using the following scenarios

\begin{itemize}
\item Switching between generating a single Val3 file and one for each subsurface
\item Custom printing patterns for the different subsurfaces
\item Varying the drip height
\item Using multiple runs by defining \verb|thickness| and \verb|thicknessPerRun|
\item Adding code snippets before and after the target is reached
\item Using makros like \verb|$run| in the added code to determine the run number
\end{itemize}

All of them yielded the expected result. Therefore, the generated paths as well as adjustments of these paths match the expectations for a variety of different models. As a last step, the Val3 code on the robot itself has to be tested, to ensure the correct movement of the robot.

\begin{figure}[H]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.49\textwidth}
		\centering
		\includegraphics[scale=0.7]{images/valve/valveFull.png}
		\caption{Subdivided model}
	\end{subfigure}
	\hspace{0.3cm}
	\begin{subfigure}[t]{0.49\textwidth}
	  \centering
		\includegraphics[scale=0.35]{images/valve/ValvePointsFull.png}
		\caption{Generated paths}
	\end{subfigure}
	\caption{Testing path generation on a heart valve model. The subsurfaces are illustrated by different colors, paths and points are shown in red, and the normals in blue.}
	\label{fig:valveTest}
\end{figure}

\begin{figure}[h]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.49\textwidth}
		\centering
		\includegraphics[scale=0.7]{images/cubeCylinder/valveFull.png}
		\caption{Subdivided model}
	\end{subfigure}
	\hspace{0.3cm}
	\begin{subfigure}[t]{0.49\textwidth}
	  \centering
		\includegraphics[scale=0.35]{images/cubeCylinder/ValvePointsFull.png}
		\caption{Generated paths}
	\end{subfigure}
	\caption{Testing path generation on a cube model with cylindric top to have a combination of surface types. The subsurfaces are illustrated by different colors, paths and points are shown in red, and the normals in blue.}
	\label{fig:cubeCylinderTest}
\end{figure}

\begin{figure}[h]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.49\textwidth}
		\centering
		\includegraphics[scale=1]{images/cylinder/valveFull.png}
		\caption{Cylindric heart valve leaflet}
	\end{subfigure}
	\hspace{0.3cm}
	\begin{subfigure}[t]{0.49\textwidth}
	  \centering
		\includegraphics[scale=0.45]{images/cylinder/ValvePointsFull.png}
		\caption{Flat plate}
	\end{subfigure}
	\caption{Testing path generation on a cube model cylinder. The subsurfaces are illustrated by different colors, paths and points are shown in red, and the normals in blue.}
	\label{fig:cylinderTest}
\end{figure}

\subsection{Robot}
For testing the movement of the robot first the cylinder model was used. It was created in such a way that it matches the size of a cylindric container shown in Figure~\ref{fig:cylinderRobot}. A video of the robot movement can be found in the \textit{docs/videos} folder of the GitLab project. The pencil in Figure~\ref{fig:cylinderRobot} represents the tip of the printer. As expected, the robot moves along the symmetry axis while aligning the calculated normals. It stops at each point along the path for a short time and continues since no additional instruction was given. Figure~\ref{fig:leafletRobot} shows a similar test case but for one leaflet of the heart valve model. Since the shape is cylindric, the robot again follows the axis of symmetry. However, now the axis lies outside of the model. Therefore, the robot holds the cylindric container at a certain angle while traversing the path.

\section{Conclusion and Future Work}

To conclude, generating equidistant points on a complex heart valve surface can be very involved. However, by reducing to smaller problems and applying some approximations, it is possible to correctly map paths onto the complex surface. These paths are first created on a flat surface, thus offering an intuitive understanding and definition. Due to the usage of Python, each step of the code can easily be adjusted or extended. Additionally, intermediate steps can be added. For example, to have the thickness of the printed model be defined by a corresponding thickness of an volumetric heart valve model. However, it is also important to notice that before using patient-specific prosthesis on actual patients, a lot of research is required.

\begin{figure}[H]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.49\textwidth}
		\centering
		\includegraphics[scale=0.367]{images/validation/cylinder1.png}
	\end{subfigure}
	\hspace{0.3cm}
	\begin{subfigure}[t]{0.49\textwidth}
	  \centering
		\includegraphics[scale=0.37]{images/validation/cylinder2.png}
	\end{subfigure}
	\caption{Movement of the robot for the cylinder model illustrated by the cylindric container. The robot follows the axis of symmetry while aligning the normals of the model and traversing the generated points.}
	\label{fig:cylinderRobot}
\end{figure}

\begin{figure}[H]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.49\textwidth}
		\centering
		\includegraphics[scale=0.367]{images/validation/leaflet1.png}
		\caption{Cylindric heart valve leaflet}
	\end{subfigure}
	\hspace{0.3cm}
	\begin{subfigure}[t]{0.49\textwidth}
	  \centering
		\includegraphics[scale=0.37]{images/validation/leaflet2.png}
		\caption{Flat plate}
	\end{subfigure}
	\caption{Movement of the robot for a leaflet of the heart valve model. The robot follows the axis of symmetry of the leaflet while aligning the normals of the model and traversing the generated points.}
	\label{fig:leafletRobot}
\end{figure}

\bibliographystyle{abbrv}
\bibliography{references}

\end{document}          
